# Class SynthProgressBarUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ProgressBarUI
javax.swing.plaf.basic.BasicProgressBarUI
javax.swing.plaf.synth.SynthProgressBarUI

All Implemented Interfaces:
  `PropertyChangeListener, EventListener, SynthConstants, SynthUI`

public class SynthProgressBarUI extends BasicProgressBarUI implements SynthUI, PropertyChangeListener
Provides the Synth L&F UI delegate for `JProgressBar`.

Since:
  1.7

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class BasicProgressBarUI

  `BasicProgressBarUI.ChangeHandler`
  Modifier and Type
  Class
  Description
  `class`
  `BasicProgressBarUI.ChangeHandler`
  This class should be treated as a "protected" inner class.

- ## Field Summary

  ### Fields declared in class BasicProgressBarUI

  `boxRect, changeListener, progressBar`
  Modifier and Type
  Field
  Description
  `protected Rectangle`
  `boxRect`
  Used to hold the location and size of the bouncing box (returned by getBox) to be painted.
  `protected ChangeListener`
  `changeListener`
  The instance of `ChangeListener`.
  `protected JProgressBar`
  `progressBar`
  The instance of `JProgressBar`.

  ### Fields declared in interface SynthConstants

  `DEFAULT, DISABLED, ENABLED, FOCUSED, MOUSE_OVER, PRESSED, SELECTED`
  Modifier and Type
  Field
  Description
  `static final int`
  `DEFAULT`
  Indicates the region is the default.
  `static final int`
  `DISABLED`
  Primary state indicating the region is not enabled.
  `static final int`
  `ENABLED`
  Primary state indicating the component is enabled.
  `static final int`
  `FOCUSED`
  Indicates the region has focus.
  `static final int`
  `MOUSE_OVER`
  Primary state indicating the mouse is over the region.
  `static final int`
  `PRESSED`
  Primary state indicating the region is in a pressed state.
  `static final int`
  `SELECTED`
  Indicates the region is selected.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SynthProgressBarUI()`
  Constructs a `SynthProgressBarUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ComponentUI`
  `createUI(JComponent x)`
  Creates a new UI object for the given component.
  `SynthContext`
  `getContext(JComponent c)`
  Returns the Context for the specified component.
  `void`
  `paint(Graphics g, JComponent c)`
  Paints the specified component according to the Look and Feel.
  `protected void`
  `paint(SynthContext context, Graphics g)`
  Paints the specified component.
  `void`
  `paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)`
  Paints the border.
  `protected void`
  `paintText(SynthContext context, Graphics g, String title)`
  Paints the component's text.
  `void`
  `propertyChange(PropertyChangeEvent e)`
  This method gets called when a bound property is changed.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate to repaint the specified component.

  ### Methods declared in class BasicProgressBarUI

  `getAmountFull, getAnimationIndex, getBaseline, getBaselineResizeBehavior, getBox, getBoxLength, getCellLength, getCellSpacing, getFrameCount, getMinimumSize, getPreferredInnerHorizontal, getPreferredInnerVertical, getSelectionBackground, getSelectionForeground, getStringPlacement, incrementAnimationIndex, installDefaults, installListeners, paintDeterminate, paintIndeterminate, paintString, setAnimationIndex, setCellLength, setCellSpacing, startAnimationTimer, stopAnimationTimer, uninstallDefaults, uninstallListeners`
  Modifier and Type
  Method
  Description
  `protected int`
  `getAmountFull(Insets b, int width, int height)`
  This determines the amount of the progress bar that should be filled based on the percent done gathered from the model.
  `protected int`
  `getAnimationIndex()`
  Gets the index of the current animation frame.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `protected Rectangle`
  `getBox(Rectangle r)`
  Stores the position and size of the bouncing box that would be painted for the current animation index in `r` and returns `r`.
  `protected int`
  `getBoxLength(int availableLength, int otherDimension)`
  Returns the length of the "bouncing box" to be painted.
  `protected int`
  `getCellLength()`
  Returns the width (if HORIZONTAL) or height (if VERTICAL) of each of the individual cells/units to be rendered in the progress bar.
  `protected int`
  `getCellSpacing()`
  Returns the spacing between each of the cells/units in the progress bar.
  `protected final int`
  `getFrameCount()`
  Returns the number of frames for the complete animation loop used by an indeterminate JProgressBar.
  `Dimension`
  `getMinimumSize(JComponent c)`
  The Minimum size for this component is 10.
  `protected Dimension`
  `getPreferredInnerHorizontal()`
  Returns preferred size of the horizontal `JProgressBar`.
  `protected Dimension`
  `getPreferredInnerVertical()`
  Returns preferred size of the vertical `JProgressBar`.
  `protected Color`
  `getSelectionBackground()`
  The "selectionBackground" is the color of the text when it is painted over an unfilled area of the progress bar.
  `protected Color`
  `getSelectionForeground()`
  The "selectionForeground" is the color of the text when it is painted over a filled area of the progress bar.
  `protected Point`
  `getStringPlacement(Graphics g, String progressString, int x, int y, int width, int height)`
  Designate the place where the progress string will be painted.
  `protected void`
  `incrementAnimationIndex()`
  Sets the index of the current animation frame, to the next valid value, which results in the progress bar being repainted.
  `protected void`
  `installDefaults()`
  Installs default properties.
  `protected void`
  `installListeners()`
  Registers listeners.
  `protected void`
  `paintDeterminate(Graphics g, JComponent c)`
  All purpose paint method that should do the right thing for almost all linear, determinate progress bars.
  `protected void`
  `paintIndeterminate(Graphics g, JComponent c)`
  All purpose paint method that should do the right thing for all linear bouncing-box progress bars.
  `protected void`
  `paintString(Graphics g, int x, int y, int width, int height, int amountFull, Insets b)`
  Paints the progress string.
  `protected void`
  `setAnimationIndex(int newValue)`
  Sets the index of the current animation frame to the specified value and requests that the progress bar be repainted.
  `protected void`
  `setCellLength(int cellLen)`
  Sets the cell length.
  `protected void`
  `setCellSpacing(int cellSpace)`
  Sets the cell spacing.
  `protected void`
  `startAnimationTimer()`
  Starts the animation thread, creating and initializing it if necessary.
  `protected void`
  `stopAnimationTimer()`
  Stops the animation thread.
  `protected void`
  `uninstallDefaults()`
  Unintalls default properties.
  `protected void`
  `uninstallListeners()`
  Removes all listeners installed by this object.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getMaximumSize, getPreferredSize, installUI, uninstallUI`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `Dimension`
  `getPreferredSize(JComponent c)`
  Returns the specified component's preferred size appropriate for the look and feel.
  `void`
  `installUI(JComponent c)`
  Configures the specified component appropriately for the look and feel.
  `void`
  `uninstallUI(JComponent c)`
  Reverses configuration which was done on the specified component during `installUI`.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SynthProgressBarUI

    public SynthProgressBarUI()
    Constructs a `SynthProgressBarUI`.

- ## Method Details

  - ### createUI

    public static ComponentUI createUI(JComponent x)
    Creates a new UI object for the given component.
    Parameters:
      `x` - component to create UI object for
    Returns:
      the UI object

  - ### getContext

    public SynthContext getContext(JComponent c)
    Returns the Context for the specified component.
    Specified by:
      `getContext` in interface `SynthUI`
    Parameters:
      `c` - Component requesting SynthContext.
    Returns:
      SynthContext describing component.

  - ### update

    public void update(Graphics g, JComponent c)
    Notifies this UI delegate to repaint the specified component. This method paints the component background, then calls the `paint(SynthContext,Graphics)` method.

    In general, this method does not need to be overridden by subclasses. All Look and Feel rendering code should reside in the `paint` method.

    Overrides:
      `update` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    public void paint(Graphics g, JComponent c)
    Paints the specified component according to the Look and Feel.

    This method is not used by Synth Look and Feel. Painting is handled by the `paint(SynthContext,Graphics)` method.

    Overrides:
      `paint` in class `BasicProgressBarUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    protected void paint(SynthContext context, Graphics g)
    Paints the specified component.
    Parameters:
      `context` - context for the component being painted
      `g` - the `Graphics` object used for painting
    See Also:
      - `update(Graphics,JComponent)`

  - ### paintText

    protected void paintText(SynthContext context, Graphics g, String title)
    Paints the component's text.
    Parameters:
      `context` - context for the component being painted
      `g` - `Graphics` object used for painting
      `title` - the text to paint

  - ### paintBorder

    public void paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)
    Paints the border.
    Specified by:
      `paintBorder` in interface `SynthUI`
    Parameters:
      `context` - a component context
      `g` - `Graphics` to paint on
      `x` - the X coordinate
      `y` - the Y coordinate
      `w` - width of the border
      `h` - height of the border

  - ### propertyChange

    public void propertyChange(PropertyChangeEvent e)
    This method gets called when a bound property is changed.
    Specified by:
      `propertyChange` in interface `PropertyChangeListener`
    Parameters:
      `e` - A PropertyChangeEvent object describing the event source and the property that has changed.